#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using HeuristicLab.Problems.DataAnalysis;

namespace HeuristicLab.Algorithms.DataAnalysis {
  /// <summary>
  /// Interface to represent a Gaussian process posterior
  /// </summary>
  public interface IGaussianProcessModel : IRegressionModel {
    double NegativeLogLikelihood { get; }
    double SigmaNoise { get; }
    IMeanFunction MeanFunction { get; }
    ICovarianceFunction CovarianceFunction { get; }
    double[] HyperparameterGradients { get; }

    IEnumerable<double> GetEstimatedVariance(Dataset ds, IEnumerable<int> rows);
    void FixParameters();
  }
}
